org.eclipse.jetty.util.resource

## Class FileResource

- java.lang.Object
- - org.eclipse.jetty.util.resource.Resource
  - - org.eclipse.jetty.util.resource.URLResource
    - - org.eclipse.jetty.util.resource.FileResource

All Implemented Interfaces:
  ResourceFactory

    public class FileResource
    extends URLResource

File Resource. Handle resources of implied or explicit file type. This class can check for aliasing in the filesystem (eg case insensitivity). By default this is turned on, or it can be controlled by calling the static method @see FileResource#setCheckAliases(boolean)

### Field Summary

### Fields inherited from class org.eclipse.jetty.util.resource.URLResource

`_connection, _in, _url, _urlString`

### Fields inherited from class org.eclipse.jetty.util.resource.Resource

`__defaultUseCaches`

### Constructor Summary

Constructors
Constructor and Description
`FileResource(URL url)`

### Method Summary

Methods
`Resource` `addPath(String path)` Returns the resource contained inside the current resource with the given name
`void` `copyTo(File destination)`
`boolean` `delete()` Deletes the given resource
`String` `encode(String uri)` Encode according to this resource type.
`boolean` `equals(Object o)`
`boolean` `exists()` Returns true if the resource exists.
`URL` `getAlias()`
`static boolean` `getCheckAliases()` getCheckAliases.
`File` `getFile()` Returns an File representing the given resource or NULL if this is not possible.
`InputStream` `getInputStream()` Returns an input stream to the resource
`String` `getName()` Returns the name of the resource
`OutputStream` `getOutputStream()` Returns an output stream to the resource
`int` `hashCode()`
`boolean` `isDirectory()` Returns true if the respresenetd resource is a container/directory.
`long` `lastModified()` Returns the last modified time
`long` `length()` Return the length of the resource
`String[]` `list()` Returns a list of resources contained in the given resource
`boolean` `renameTo(Resource dest)` Rename the given resource
`static void` `setCheckAliases(boolean checkAliases)` setCheckAliases.

### Methods inherited from class org.eclipse.jetty.util.resource.URLResource

`checkConnection, getURL, getUseCaches, isContainedIn, release, toString`

### Methods inherited from class org.eclipse.jetty.util.resource.Resource

`finalize, getAssociate, getDefaultUseCaches, getListHTML, getResource, getURI, getWeakETag, isContainedIn, newClassPathResource, newClassPathResource, newResource, newResource, newResource, newResource, newResource, newSystemResource, setAssociate, setDefaultUseCaches, toURL, writeTo`

### Methods inherited from class java.lang.Object

`clone, getClass, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### FileResource

    public FileResource(URL url)
                 throws IOException,
                        URISyntaxException

Throws:
  `IOException`
  `URISyntaxException`

### Method Detail

#### setCheckAliases

    public static void setCheckAliases(boolean checkAliases)

setCheckAliases.

Parameters:
  `checkAliases` - True of resource aliases are to be checked for (eg case insensitivity or 8.3 short names) and treated as not found.

#### getCheckAliases

    public static boolean getCheckAliases()

getCheckAliases.

Returns:
  True of resource aliases are to be checked for (eg case insensitivity or 8.3 short names) and treated as not found.

#### addPath

    public Resource addPath(String path)
                     throws IOException,
                            MalformedURLException

Description copied from class: `URLResource`
Returns the resource contained inside the current resource with the given name

Overrides:
  `addPath` in class `URLResource`
Parameters:
  `path` - The path segment to add, which should be encoded by the encode method.
Throws:
  `IOException`
  `MalformedURLException`

#### getAlias

    public URL getAlias()

Overrides:
  `getAlias` in class `Resource`
Returns:
  The canonical Alias of this resource or null if none.

#### exists

    public boolean exists()

Returns true if the resource exists.

Overrides:
  `exists` in class `URLResource`

#### lastModified

    public long lastModified()

Returns the last modified time

Overrides:
  `lastModified` in class `URLResource`

#### isDirectory

    public boolean isDirectory()

Returns true if the respresenetd resource is a container/directory.

Overrides:
  `isDirectory` in class `URLResource`

#### length

    public long length()

Return the length of the resource

Overrides:
  `length` in class `URLResource`

#### getName

    public String getName()

Returns the name of the resource

Overrides:
  `getName` in class `URLResource`

#### getFile

    public File getFile()

Returns an File representing the given resource or NULL if this is not possible.

Overrides:
  `getFile` in class `URLResource`

#### getInputStream

    public InputStream getInputStream()
                               throws IOException

Returns an input stream to the resource

Overrides:
  `getInputStream` in class `URLResource`
Throws:
  `IOException`

#### getOutputStream

    public OutputStream getOutputStream()
                                 throws IOException,
                                        SecurityException

Returns an output stream to the resource

Overrides:
  `getOutputStream` in class `URLResource`
Throws:
  `IOException`
  `SecurityException`

#### delete

    public boolean delete()
                   throws SecurityException

Deletes the given resource

Overrides:
  `delete` in class `URLResource`
Throws:
  `SecurityException`

#### renameTo

    public boolean renameTo(Resource dest)
                     throws SecurityException

Rename the given resource

Overrides:
  `renameTo` in class `URLResource`
Throws:
  `SecurityException`

#### list

    public String[] list()

Returns a list of resources contained in the given resource

Overrides:
  `list` in class `URLResource`

#### encode

    public String encode(String uri)

Encode according to this resource type. File URIs are encoded.

Overrides:
  `encode` in class `Resource`
Parameters:
  `uri` - URI to encode.
Returns:
  The uri unchanged.

#### equals

    public boolean equals(Object o)

Overrides:
  `equals` in class `URLResource`
Parameters:
  `o` -
Returns:
  `true` of the object `o` is a `FileResource` pointing to the same file as this resource.

#### hashCode

    public int hashCode()

Overrides:
  `hashCode` in class `URLResource`
Returns:
  the hashcode.

#### copyTo

    public void copyTo(File destination)
                throws IOException

Overrides:
  `copyTo` in class `Resource`
Throws:
  `IOException`